<template>
    <div class="worker-list">
        <div class="config">
            <div>
                <h1>Basic</h1>
                <label>Floor plan image <input v-model="src"/></label>
                <button @click="clear">Clear</button>
                <br>

                <label>Width <input v-model="width"/></label>
                <label>Height<input v-model="height"/></label>
                <label>End X<input v-model="X"/></label>
                <label>End Y<input v-model="Y"/></label>


                <h1>Push settings</h1>
                <label>Push Interval<input v-model="pushInterval"></label>
                <label>Push positions<input type="checkbox" v-model="autoPush"></label>
                <label>Movement Speed<input v-model="speed"></label>
                <button @click="save">Save</button>
                <button @click="load">Load</button>
                <br>
                <br>
            </div>
            <div>
                <h1>MiddleWare Setting</h1>
                <label>Endpoint<input style="width:300px" v-model="endpoint"/></label>
                <label>Interval<input v-model="interval"/></label>
                {{count}}
                <hr>
                <div class="anchors" v-for="(item, key) in tags">
                    {{key}}:
                    <label>uuid:<input @change="update" v-model="item.uuid"></label>
                    <label>sync<input @change="update" type="checkbox" v-model="item.sync"></label>

                    <button v-if="!isSelected(key)" @click="Select(key)">Select</button>

                </div>
                <div class="error">{{tagError}}</div>
                <div class="message">{{tagMessage}}</div>
                <label>Mac<input v-model="tagMac"/></label>
                <label>UUID<input v-model="tagUuid"/></label>
                <button @click="CreateTag">Create Tag</button>

                <hr>
                <div class="anchors" v-for="(item, key) in anchors">
                    {{key}}:
                    <label>x:<input @change="update" v-model="item.x"></label>
                    <label>y:<input @change="update" v-model="item.y"></label>
                    <label>radius: <input @change="update" v-model="item.radius"></label>
                </div>
                <label>Mac<input v-model="anchorMac"/></label>
                <label>Radius<input v-model="anchorRadius"/></label>
                <label>Anchor X<input v-model="anchorX"/></label>
                <label>Anchor Y<input v-model="anchorY"/></label>
                <button @click="CreateAnchor">Create Anchor</button>
                <br>
                <div class="error">{{anchorError}}</div>
                <div class="message">{{anchorMessage}}</div>
                <button @click="UpdateMiddleware">Update MiddleWare</button>
                <br>
            </div>
        </div>
        <div class="floor-plan" :style="Style">
            <img class='max' :src="src" alt="floor-plan">
            <div class="dot" v-for="(item,key) in tags" :style="{
                    top: getYPositionTag(key),
                    left: getXPositionTag(key),
            }">
                <div class="label">
                    {{item.macAddress}}
                </div>

            </div>
            <div class="range" v-for="(item, key) in anchors" :style="{
                    top: getYPosition(key),
                    left: getXPosition(key),
                    width: (item.radius*2/X)*100 + '%',
                    height: (item.radius*2/Y)*100 + '%',
                }">
                <div class="anchor-node" :style="{

                    }">
                </div>
            </div>
        </div>
    </div>
</template>

<style lang='scss' scoped>
    .worker-list {
        font-family: "Roboto Light", sans-serif;

        .config {
            display: flex;
        }

        .error {
            color: red;

        }

        .range {
            border-radius: 50%;
            position: absolute;
            background: #FF000040;
            border: 1px solid red;
            transform: translate(-50%, -50%);
        }

        .anchor-node {
            position: relative;
            width: 10px;
            height: 10px;
            background: black;
            border-radius: 50%;
            transform: translate(-50%, -50%);
            top: 50%;
            left: 50%;
            transition: left 1s, top 1s;
        }

        .dot {
            position: absolute;
            width: 10px;
            height: 10px;
            background: blue;
            border-radius: 50%;
            transform: translate(-50%, -50%);
            transition: left 0.1s, top 0.1s;

            .label {
                font-size: 12px;
                font-family: "Roboto Light", sans-serif;
                transform: translate(-50%, -100%);
            }
        }


        .max {
            position: absolute;
            width: 100%;
            height: 100%;
        }

        .floor-plan {
            position: relative;
            border: 3px dashed black;
            background: white;
        }


    }
</style>

<script lang='ts'>
    import {Component, Vue} from 'vue-property-decorator';
    import {HttpClient} from "../../../classLibrary/Client";
    import {Anchor, Tags} from "../../../classLibrary/Anchor";


    @Component({})
    export default class WorkerList extends Vue {
        http: HttpClient = new HttpClient();
        width: number = 600;
        height: number = 600;
        X: number = 600;
        Y: number = 600;
        src: string = '';
        anchorX: number = 0;
        anchorY: number = 0;
        anchors: { [s: string]: Anchor } = {};
        anchorRadius: number = 0;
        anchorMac: string = '';
        anchorError: string = '';
        anchorMessage: string = '';
        endpoint: string = 'https://dev.ble.buildify.atomi.cloud';
        count = false;
        interval: number = 10;

        tags: { [s: string]: Tags } = {};
        tagUuid: string = '';
        tagMac: string = '';
        tagError: string = '';
        tagMessage: string = '';

        selectedTag: string = '';

        //push settings
        autoPush: boolean = false;
        pushInterval: number = 1000;
        speed: number = 5;

        clear() {
            this.src = ''
        }

        save() {
            const data = {
                width: this.width,
                height: this.height,
                X: this.X,
                Y: this.Y,
                src: this.src,
                anchors: this.anchors,
                tags: this.tags,
                endpoint: this.endpoint,
                interval: this.interval,
                pushInterval: this.pushInterval,
                speed: this.speed,
            };
            const s = JSON.stringify(data);
            localStorage.setItem("DATA", s);
        }

        load() {
            const s = localStorage.getItem("DATA");
            if (s != null) {
                const data = JSON.parse(s);
                this.width = data.width;
                this.height = data.height;
                this.X = data.X;
                this.Y = data.Y;
                this.src = data.src;
                this.anchors = data.anchors;
                this.tags = data.tags;
                this.endpoint = data.endpoint;
                this.interval = data.interval;
                this.pushInterval = data.pushInterval;
                this.speed = data.speed;
            }
        }

        move(event: KeyboardEvent) {
            const tag = this.tags[this.selectedTag];
            if (tag == null) return;
            if (event.keyCode == 37) {
                tag.x = (tag.x - this.speed.ToFloat()).AtMax(this.X).AtMin(0)
            } else if (event.keyCode == 39) {
                tag.x = (tag.x + this.speed.ToFloat()).AtMax(this.X).AtMin(0)
            } else if (event.keyCode == 38) {
                tag.y = (tag.y - this.speed.ToFloat()).AtMax(this.Y).AtMin(0)
            } else if (event.keyCode == 40) {
                tag.y = (tag.y + this.speed.ToFloat()).AtMax(this.Y).AtMin(0)
            }
            if ([37, 38, 39, 40].Any(e => e === event.keyCode)) {
                this.update();
            }
        }


        isSelected(uuid: any): boolean {
            return uuid == this.selectedTag;
        }

        Select(uuid: any) {
            this.selectedTag = uuid;
        }

        update() {
            this.count = !this.count;
        }

        CreateTag() {
            if (this.tagMac == '') {
                this.tagError = "macAddress empty";
                return;
            }
            if (this.tagUuid == '') {
                this.tagError = "uuid empty";
                return;
            }
            if (this.tags[this.tagMac] != null) {
                this.tagError = 'mac address already exist.';
                return;
            }
            this.tags[this.tagMac] = {
                macAddress: this.tagMac,
                uuid: this.tagUuid,
                x: 0,
                y: 0,
                sync: true,
            };
            this.tagMac = '';
            this.tagUuid = '';
            this.tagError = '';
            this.tagMessage = 'Created new tag';
        }

        CreateAnchor() {
            if (this.anchorMac == '') {
                this.anchorError = "macAddress empty";
                return;
            }
            if (this.anchors[this.anchorMac] != null) {
                this.anchorError = 'mac address already exist.';
                return;
            }
            if (this.anchorRadius < 1) {
                this.anchorRadius = 5;
            }
            this.anchors[this.anchorMac] = {
                macAddress: this.anchorMac,
                x: this.anchorX,
                y: this.anchorY,
                radius: this.anchorRadius,
            };
            this.anchorRadius = 0;
            this.anchorMac = '';
            this.anchorX = 0;
            this.anchorY = 0;
            this.anchorError = '';
            this.anchorMessage = 'Created new anchor';
        }


        get Style() {
            return {
                width: this.width + "px",
                height: this.height + "px",
            }
        }

        getXPosition(key: string): string {
            return (this.anchors[key].x / this.X) * 100 + "%";
        }

        getYPosition(key: any): string {
            return (this.anchors[key].y / this.Y) * 100 + "%";
        }

        getXPositionTag(key: any): string {
            return (this.tags[key].x / this.X) * 100 + "%";
        }

        getYPositionTag(key: any): string {
            return (this.tags[key].y / this.Y) * 100 + "%";
        }

        async UpdateMiddleware() {
            const body: any = {
                interval: this.interval.ToInt(),
                tags: {},
                beacons: {},
            };
            for (let k in this.tags) {
                if (this.tags.hasOwnProperty(k)) {
                    const tag = this.tags[k];
                    body.tags[tag.macAddress] = tag.uuid;
                }
            }
            for (let k in this.anchors) {
                if (this.anchors.hasOwnProperty(k)) {
                    const anchor = this.anchors[k];
                    body.beacons[anchor.macAddress] = {
                        x: anchor.x.ToInt(),
                        y: anchor.y.ToInt(),
                    };
                }
            }
            const endpoint = this.endpoint + "/config";
            const resp = await this.http.ping(endpoint, "PUT", body);
            if (!resp.ok) {
                console.log("Failed", resp.text());
            }

        }

        async push() {
            if (this.autoPush) {
                this.pushCurrent();
            }
            setTimeout(this.push, this.pushInterval)
        }

        async pushCurrent() {
            for (let k in this.anchors) {
                const anchor = this.anchors[k];
                for (let t in this.tags) {
                    const tag = this.tags[t];
                    if (tag.sync) {
                        const distance = Math.sqrt((anchor.x - tag.x) ** 2 + (anchor.y - tag.y) ** 2);
                        console.log(anchor.macAddress, tag.macAddress, distance, anchor.radius, tag.x, tag.y);
                        if (distance < anchor.radius) {
                            this.pushSingle(anchor.macAddress, tag.macAddress, distance);
                        }
                    }
                }
            }
        }

        async pushSingle(nodeMac: string, tagMac: string, rssi: number) {
            const body: any = {
                Mac: nodeMac,
                Tag: {}
            };
            body.Tag[tagMac] = rssi;
            const endpoint = this.endpoint + "/position";
            const resp = await this.http.ping(endpoint, "POST", body);
            if (!resp.ok) {
                console.log("Failed", resp.text());
            }


        }

        async mounted() {
            this.push();
            document.removeEventListener('keydown', this.move);
            document.addEventListener('keydown', this.move);
        }

        destroyed() {
            document.removeEventListener('keydown', this.move);
        }

    }
</script>
